	bool TestStack(void)
	{
		u_char *threadStartLocation_ptr;
		u_char *threadpointerLocation_ptr;
		size_t actualstackSize;
		unsigned int threadCount = 0;
		unsigned int stackByteLocation = 0;
		unsigned int abbaFeedCount = 0;
		unsigned int stackPercentFree = 0;
		size_t heapAvailable;
				
		TRACE(" Number of Threads %d ",numberOfThreads);

		heapAvailable = NutHeapAvailable();
		TRACE("Available heap %d",heapAvailable);

		/* work through each thread, count how many 0xFEEDABBA remain untouched in ram  */
		for(threadCount = 0; threadCount < numberOfThreads; threadCount++){
		
			actualstackSize = inFactstackTest[threadCount].stackSize;
			threadStartLocation_ptr = inFactstackTest[threadCount].startAddres_ptr;
			threadpointerLocation_ptr = threadStartLocation_ptr;

			abbaFeedCount = 0;
			
			for(stackByteLocation = 0;stackByteLocation < actualstackSize; stackByteLocation++){
				/* check every 4th byte for contents of memory == 0xFEEDABBA */						
				if(((stackByteLocation & 0x03) == 0)){
					if(*((u_long *) threadpointerLocation_ptr) == FEEDABBA){			
						abbaFeedCount = abbaFeedCount + 1;
					}
				}
				threadpointerLocation_ptr++;
			}
			
			/* Divide by 4 (bytes per 0xABBAFEED)  * 100 to get percentage  */
			stackPercentFree = (((unsigned long)abbaFeedCount*400)/(unsigned long)actualstackSize);

			TRACE(" Thread: %d  Name: %s  Start ptr: %u  Size: %d  Unused: %d  Percent-free: %d ",threadCount,inFactstackTest[threadCount].stack_name, (unsigned int)threadStartLocation_ptr,actualstackSize, abbaFeedCount*4,stackPercentFree);
			
			//If stack levels below 20%, or heap below 1000-bytes.
			if( (stackPercentFree <= MIN_STACK_SIZE) || (heapAvailable < 1000L) ){
				//Low stack
				return FALSE;
			}	
		}
		return TRUE;
	}